xref: /haiku/configure (revision 961fc581b72510cee93b8920e85f7eea3505c46a)
152a38012Sejakowatz#!/bin/sh
252a38012Sejakowatz#
3338b8dc3SIngo Weinhold# configure [ <options> ]
4614026d7Sshatty
539d444a3SArvind S Raj# set flag to exit script when exit command is executed
639d444a3SArvind S Rajset -e
739d444a3SArvind S Raj
8022fa244SIngo Weinhold# usage
9022fa244SIngo Weinhold#
10022fa244SIngo Weinhold# Prints usage.
11022fa244SIngo Weinhold#
12022fa244SIngo Weinholdusage()
13022fa244SIngo Weinhold{
14022fa244SIngo Weinhold	cat << EOF
15022fa244SIngo Weinhold
16022fa244SIngo WeinholdUsage: $0 <options>
17022fa244SIngo Weinholdoptions:
18e173a1ecSIngo Weinhold  --bootstrap <haikuporter> <HaikuPorts cross repo> <HaikuPorts repo>
19e173a1ecSIngo Weinhold                              Prepare for a bootstrap build. No pre-built
20e173a1ecSIngo Weinhold                              packages will be used, instead they will be built
21e173a1ecSIngo Weinhold                              from the sources (in several phases).
22e173a1ecSIngo Weinhold                              <haikuporter> is the path to the haikuporter tool
23e173a1ecSIngo Weinhold                              suitable for the host platform.
24e173a1ecSIngo Weinhold                              <HaikuPorts cross repo> is the path to a checked
25e173a1ecSIngo Weinhold                              out HaikuPorts cross-compilation repository.
26e173a1ecSIngo Weinhold                              <HaikuPorts repo> is the path to a checked out
27e173a1ecSIngo Weinhold                              HaikuPorts repository.
28c0e8cc1aSIngo Weinhold  --build-cross-tools <arch> [ <build tools dir> ]
29338b8dc3SIngo Weinhold                              Assume cross compilation. <build tools dir>
30338b8dc3SIngo Weinhold                              defines the location of the build tools sources.
31338b8dc3SIngo Weinhold                              They will be compiled and placed in the output
32a5b60fa8SOliver Tappe                              directory under "cross-tools". The HAIKU_* tools
33a5b60fa8SOliver Tappe                              variables will be set accordingly.
3420ab75e6SIngo Weinhold                              <arch> specifies the target architecture, either
351b38c341SAlexander von Gluck IV                              "x86_gcc2", "x86", "x86_64", "ppc", "m68k", "arm"
36c0e8cc1aSIngo Weinhold                              This option and --cross-tools-prefix can be
37c0e8cc1aSIngo Weinhold                              specified multiple times. The first cross tools
38c0e8cc1aSIngo Weinhold                              specify the primary tools, the subsequent ones the
39c0e8cc1aSIngo Weinhold                              secondary tools (for "hybrid" images).
40c0e8cc1aSIngo Weinhold                              For the first --build-cross-tools the
41c0e8cc1aSIngo Weinhold                              <build tools dir> argument must be specified and
42c0e8cc1aSIngo Weinhold                              for the subsequent ones it must be omitted.
43eccc7665SIngo Weinhold  --cross-tools-prefix <prefix>
44eccc7665SIngo Weinhold                              Assume cross compilation. <prefix> should be a
45eccc7665SIngo Weinhold                              path to the directory where the cross
46eccc7665SIngo Weinhold                              compilation tools are located, plus the platform
470da9c208SIngo Weinhold                              prefix, e.g. "/path/to/tools/i586-pc-haiku-".
48eccc7665SIngo Weinhold                              This overrides the HAIKU_* tool variables.
49a66c32ddSIngo Weinhold  --distro-compatibility <level>
50a66c32ddSIngo Weinhold                              The distribution's level of compatibility with
51a66c32ddSIngo Weinhold                              the official Haiku distribution. The generated
52a66c32ddSIngo Weinhold                              files will contain the respective trademarks
53a66c32ddSIngo Weinhold                              accordingly.
54a66c32ddSIngo Weinhold                              official -- the official Haiku distribution.
55a66c32ddSIngo Weinhold                              compatible -- a Haiku Compatible (tm) distro.
56a66c32ddSIngo Weinhold                              default -- any other distro (default value).
5760d8d8fcSIngo Weinhold  --enable-multiuser          Enable experimental multiuser support.
58eccc7665SIngo Weinhold  --help                      Prints out this help.
592ebcd86dSIngo Weinhold  --host-only                 Configure for building tools for the build host
602ebcd86dSIngo Weinhold                              only. Haiku cannot be built when configured like
612ebcd86dSIngo Weinhold                              this.
62eccc7665SIngo Weinhold  --include-gpl-addons        Include GPL licensed add-ons.
6367838392SAxel Dörfler  --include-patented-code     Enable code that is known to implemented patented
6467838392SAxel Dörfler                              ideas and techniques. If this option is not
6567838392SAxel Dörfler                              specified, the resulting distribution may still
6667838392SAxel Dörfler                              implement patented ideas and techniques. This
6767838392SAxel Dörfler                              option only disables code that is currently known
6867838392SAxel Dörfler                              to be problematic.
6976fa0be3SIngo Weinhold  --include-sources           Includes the source code of projects that require
7076fa0be3SIngo Weinhold                              either an offer of source code or a copy of the
7176fa0be3SIngo Weinhold                              patched sources. This is preferable when
7276fa0be3SIngo Weinhold                              distributing on physical mediums.
731974210fSFrançois Revol  --include-3rdparty          Include 3rdparty/ in the build system.
744880ae01SJessica Hamilton  -j<n>                       Only relevant for --build-cross-tools. Is passed
754880ae01SJessica Hamilton                              on to the make building the build tools.
76aa2e5ecaSOliver Tappe  --no-downloads              Do not download anything. Useful when trying to
77aa2e5ecaSOliver Tappe                              bootstrap and build Haiku from source only.
787c4641d0SOliver Tappe  --target=TARGET             Select build target platform.
797c4641d0SOliver Tappe                              [default=${TARGET_PLATFORM}]
80a17b9c0cSshatty                              valid targets=r5,bone,dano,haiku
81483b28e4SIngo Weinhold  --target-arch <arch>        Haiku only: Specify the target architecture to
82483b28e4SIngo Weinhold                              build for. Must be one of the architectures of the
83483b28e4SIngo Weinhold                              host system. The installed build tools for that
84483b28e4SIngo Weinhold                              architecture will be used.
85483b28e4SIngo Weinhold                              This option can be specified multiple times. The
86483b28e4SIngo Weinhold                              first occurrence specifies the primary
87483b28e4SIngo Weinhold                              architecture of the Haiku to build, subsequent
88483b28e4SIngo Weinhold                              ones the secondary architectures.
89e70c4c64SPulkoMandy  --target-board <board>      ARM only: Specify the board to build for. Must be
909c5e234cSAlexander von Gluck IV                              one of beagle,rpi1,rpi2,cubieboard4,verdex,overo.
91961fc581SFrançois Revol  --update                    re-runs last configure invocation [must be given
927c4641d0SOliver Tappe                              as first option!]
93c2b76f7fSJonathan Schleifer  --use-clang                 Build with host Clang instead of GCC cross
94c2b76f7fSJonathan Schleifer                              compiler
95eccc7665SIngo Weinhold  --use-gcc-pipe              Build with GCC option -pipe. Speeds up the build
965a34a443SFrançois Revol                              process, but uses more memory.
97ed38d2efSJerome Duval  --use-gcc-graphite          Build with GCC Graphite engine for loop
98ed38d2efSJerome Duval                              optimizations. Only for gcc 4.
990385b065SIngo Weinhold  --use-32bit                 Use -m32 flag on 64bit host gcc compiler.
100bc96e8f3SIngo Weinhold  --use-xattr                 Use Linux xattr respectively *BSD extattr support
101bc96e8f3SIngo Weinhold                              for BeOS attribute emulation. Warning: Make sure
102bc96e8f3SIngo Weinhold                              your file system supports sufficient attribute
103bc96e8f3SIngo Weinhold                              sizes (4 KB per file for all attributes won't
104bc96e8f3SIngo Weinhold                              suffice).
105bc96e8f3SIngo Weinhold  --use-xattr-ref             Use the generic BeOS attribute emulation, but use
106bc96e8f3SIngo Weinhold                              Linux xattr respectively *BSD extattr support to
107bc96e8f3SIngo Weinhold                              make it more robust (i.e. attribute mix-ups become
108bc96e8f3SIngo Weinhold                              less likely).
109338b8dc3SIngo Weinhold
110338b8dc3SIngo Weinholdenvironment variables:
11163701e7dSOliver Tappe  CC                          The host compiler. Defaults to "gcc".
112c0e8cc1aSIngo Weinhold  HAIKU_AR_x86_gcc2           The static library archiver for x86_gcc2.
113c0e8cc1aSIngo Weinhold                              Defaults to "ar".
114c0e8cc1aSIngo Weinhold  HAIKU_CC_x86_gcc2           The x86_gcc2 compiler. Defaults to "gcc".
115c0e8cc1aSIngo Weinhold  HAIKU_LD_x86_gcc2           The x86_gcc2 linker. Defaults to "ld".
116c0e8cc1aSIngo Weinhold  HAIKU_OBJCOPY_x86_gcc2      The x86_gcc2 objcopy to be used. Defaults to
117c0e8cc1aSIngo Weinhold                              "objcopy".
118c0e8cc1aSIngo Weinhold  HAIKU_RANLIB_x86_gcc2       The static library indexer for x86_gcc2. Defaults
119c0e8cc1aSIngo Weinhold                              to "ranlib".
120c0e8cc1aSIngo Weinhold  HAIKU_STRIP_x86_gcc2        The x86_gcc2 strip command. Defaults to "strip".
121a04a520bSJonathan Schleifer  HAIKU_NASM                  The nasm assembler (x86 and x86_64 only).
122c0e8cc1aSIngo Weinhold  HAIKU_CPPFLAGS_<arch>       The preprocessor flags for target architecture
123c0e8cc1aSIngo Weinhold                              <arch>. Defaults to "".
124c0e8cc1aSIngo Weinhold  HAIKU_CCFLAGS_<arch>        The C flags for target architecture <arch>.
125c0e8cc1aSIngo Weinhold                              Defaults to "".
126c0e8cc1aSIngo Weinhold  HAIKU_CXXFLAGS_<arch>       The C++ flags for target architecture <arch>.
127c0e8cc1aSIngo Weinhold                              Defaults to "".
128c0e8cc1aSIngo Weinhold  HAIKU_LDFLAGS_<arch>        The linker flags for target architecture <arch>.
129c0e8cc1aSIngo Weinhold                              Defaults to "".
130c0e8cc1aSIngo Weinhold  HAIKU_ARFLAGS_<arch>        The flags passed to HAIKU_AR for target
131c0e8cc1aSIngo Weinhold                              architecture <arch> for archiving. Defaults to
132c0e8cc1aSIngo Weinhold                              "cru".
133c0e8cc1aSIngo Weinhold  HAIKU_UNARFLAGS_<arch>      The flags passed to HAIKU_AR for target
134c0e8cc1aSIngo Weinhold                              architecture <arch> for unarchiving. Defaults to
135c0e8cc1aSIngo Weinhold                              "x".
13664f6da31SIngo Weinhold
137c0e8cc1aSIngo WeinholdNon-default output directories:
13864f6da31SIngo Weinhold  By default all objects, build configuration, and other related files are
13964f6da31SIngo Weinhold  stored in /path/to/haiku_source/generated.  To store objects in a non-default
14064f6da31SIngo Weinhold  location, run "../../relative/path/to/haiku_source/configure <options>" from
14164f6da31SIngo Weinhold  within your non-default location.  "jam [ options ] targets" can then be run
14264f6da31SIngo Weinhold  directly inside your non-default location.  Another option is to invoke "jam
14364f6da31SIngo Weinhold  [ options ] targets" from within haiku_source.  This can be accomplished by
14464f6da31SIngo Weinhold  either "export HAIKU_OUTPUT_DIR=your non-default location" before invoking
14564f6da31SIngo Weinhold  jam or by creating a symlink of haiku_source/generated pointing to your
14664f6da31SIngo Weinhold  non-default location and running jam.
14764f6da31SIngo Weinhold
14864f6da31SIngo Weinhold
149022fa244SIngo WeinholdEOF
150022fa244SIngo Weinhold}
151022fa244SIngo Weinhold
152022fa244SIngo Weinhold# assertparam
153022fa244SIngo Weinhold#
154022fa244SIngo Weinhold# Checks whether at least one parameter is left.
155022fa244SIngo Weinhold#
156022fa244SIngo Weinholdassertparam()
157022fa244SIngo Weinhold{
15820ab75e6SIngo Weinhold	if [ $2 -lt 2 ]; then
159022fa244SIngo Weinhold		echo $0: \`$1\': Parameter expected.
160022fa244SIngo Weinhold		exit 1
161022fa244SIngo Weinhold	fi
162022fa244SIngo Weinhold}
163022fa244SIngo Weinhold
16420ab75e6SIngo Weinhold# assertparams
16520ab75e6SIngo Weinhold#
16620ab75e6SIngo Weinhold# Checks whether at least a certain number of parameters is left.
16720ab75e6SIngo Weinhold#
16820ab75e6SIngo Weinholdassertparams()
16920ab75e6SIngo Weinhold{
17020ab75e6SIngo Weinhold	if [ $3 -le $2 ]; then
17120ab75e6SIngo Weinhold		echo $0: \`$1\': Not enough parameters.
17220ab75e6SIngo Weinhold		exit 1
17320ab75e6SIngo Weinhold	fi
17420ab75e6SIngo Weinhold}
17520ab75e6SIngo Weinhold
176e173a1ecSIngo Weinhold# absolute_path
177e173a1ecSIngo Weinhold#
178e173a1ecSIngo Weinhold# returns the absolute path of a given path.
179e173a1ecSIngo Weinhold#
180e173a1ecSIngo Weinholdabsolute_path()
181e173a1ecSIngo Weinhold{
1826a4f3954SFrançois Revol	if [ "x$1" != "x${1#/}" ]; then
183e173a1ecSIngo Weinhold		echo "$1"
184e173a1ecSIngo Weinhold	else
185e173a1ecSIngo Weinhold		echo "`pwd`/$1"
186e173a1ecSIngo Weinhold	fi
187e173a1ecSIngo Weinhold}
188e173a1ecSIngo Weinhold
18939d444a3SArvind S Raj# check_dir_exists
19039d444a3SArvind S Raj#
19139d444a3SArvind S Raj# check if a directory exists or not
19239d444a3SArvind S Raj#
19339d444a3SArvind S Rajcheck_dir_exists()
19439d444a3SArvind S Raj{
19539d444a3SArvind S Raj	if [ -d "$1" ]; then
19639d444a3SArvind S Raj		return 0
19739d444a3SArvind S Raj	else
19839d444a3SArvind S Raj		return 1
19939d444a3SArvind S Raj	fi
20039d444a3SArvind S Raj}
20139d444a3SArvind S Raj
202502882dbSJessica Hamilton# check_file_exists
203502882dbSJessica Hamilton#
204502882dbSJessica Hamilton# check if a file exists or not
205502882dbSJessica Hamilton#
206502882dbSJessica Hamiltoncheck_file_exists()
207502882dbSJessica Hamilton{
208502882dbSJessica Hamilton	if [ -f "$1" ]; then
209502882dbSJessica Hamilton		return 0
210502882dbSJessica Hamilton	else
211502882dbSJessica Hamilton		return 1
212502882dbSJessica Hamilton	fi
213502882dbSJessica Hamilton}
214502882dbSJessica Hamilton
2159a001156SOliver Tappe# real_path
2169a001156SOliver Tappe#
2179a001156SOliver Tappe# returns the realpath of a symbolic link.
2189a001156SOliver Tappe#
2199a001156SOliver Tappereal_path()
2209a001156SOliver Tappe{
2219a001156SOliver Tappe	perl -MCwd=realpath -e'print realpath($ARGV[0]), "\n"' "$1"
2229a001156SOliver Tappe}
2239a001156SOliver Tappe
22409c5682dSIngo Weinhold# standard_gcc_settings
22509c5682dSIngo Weinhold#
22609c5682dSIngo Weinhold# Sets the variables for a GCC platform.
22709c5682dSIngo Weinhold#
22809c5682dSIngo Weinholdstandard_gcc_settings()
22909c5682dSIngo Weinhold{
230c0e8cc1aSIngo Weinhold	local gcc=$1
231c0e8cc1aSIngo Weinhold
232138f5fb4SIngo Weinhold	if which greadlink > /dev/null 2>&1; then
233b29b48b1SMatt Madia		readlink="greadlink -e"
234138f5fb4SIngo Weinhold	elif which realpath > /dev/null 2>&1; then
235b29b48b1SMatt Madia		readlink=realpath
2369a001156SOliver Tappe	elif readlink -e / > /dev/null 2>&1; then
237b29b48b1SMatt Madia		readlink="readlink -e"
2389a001156SOliver Tappe	else
2399a001156SOliver Tappe		readlink=real_path
240b4b6d83cSMatt Madia	fi
241138f5fb4SIngo Weinhold
24209c5682dSIngo Weinhold	# PLATFORM_LINKLIBS
243c0e8cc1aSIngo Weinhold	local gcclib=`$gcc -print-libgcc-file-name`
244c0e8cc1aSIngo Weinhold	local gccdir=`dirname ${gcclib}`
2455b0f7b1bSOliver Tappe
246c0e8cc1aSIngo Weinhold	local gccRawVersion=`$gcc -dumpversion`
247c0e8cc1aSIngo Weinhold	local gccMachine=`$gcc -dumpmachine`
248338b8dc3SIngo Weinhold
249fc8967f1SIngo Weinhold	# determine architecture from machine triple
250c0e8cc1aSIngo Weinhold	case $gccMachine in
251c0e8cc1aSIngo Weinhold		arm-*)		targetCpu=arm;;
252c0e8cc1aSIngo Weinhold		i?86-*)		targetCpu=x86;;
253c0e8cc1aSIngo Weinhold		m68k-*)		targetCpu=m68k;;
254c0e8cc1aSIngo Weinhold		powerpc-*)	targetCpu=ppc;;
255c0e8cc1aSIngo Weinhold		x86_64-*)	targetCpu=x86_64;;
256fc8967f1SIngo Weinhold		*)
257c0e8cc1aSIngo Weinhold			echo "Unsupported gcc target machine: $gccMachine" >&2
258fc8967f1SIngo Weinhold			exit 1
259fc8967f1SIngo Weinhold			;;
260fc8967f1SIngo Weinhold	esac
261fc8967f1SIngo Weinhold
262c0e8cc1aSIngo Weinhold	local targetArch=$targetCpu
263fc8967f1SIngo Weinhold
264c0e8cc1aSIngo Weinhold	case $gccRawVersion in
2656cc8eecfSOliver Tappe		2.9*)
2665b0f7b1bSOliver Tappe			# check for correct (most up-to-date) legacy compiler and complain
2675b0f7b1bSOliver Tappe			# if an older one is installed
268c0e8cc1aSIngo Weinhold			if [ $gccRawVersion != $haikuRequiredLegacyGCCVersion ]; then
2695b0f7b1bSOliver Tappe				echo "GCC version $haikuRequiredLegacyGCCVersion is required!";
2705b0f7b1bSOliver Tappe				echo "Please download it from www.haiku-os.org...";
2715b0f7b1bSOliver Tappe				exit 1;
2725b0f7b1bSOliver Tappe			fi
273aaeadfcbSAlex Smith
274c0e8cc1aSIngo Weinhold			targetArch=x86_gcc2
2755b0f7b1bSOliver Tappe			;;
2768b5934c9SIngo Weinhold	esac
27765ad1ba3SAlex Smith
278c0e8cc1aSIngo Weinhold	local bootLibgcc
279c0e8cc1aSIngo Weinhold	local bootLibSupCxx
28066a7f29fSJérôme Duval	local bootCxxHeaders
281c0e8cc1aSIngo Weinhold	case $gccMachine in
2824591ebc9SAlex Smith		x86_64-*)
28366a7f29fSJérôme Duval			# Boot loader is 32-bit, need the 32-bit libs and c++ config
28411ae3c5fSOliver Tappe			bootLibgcc=`$gcc -m32 -print-file-name=libgcc.a`
285c0e8cc1aSIngo Weinhold			bootLibSupCxx=`$gcc -m32 -print-file-name=libsupc++.a`
28666a7f29fSJérôme Duval
28766a7f29fSJérôme Duval			local headersBase=$gccdir/../../../..
28866a7f29fSJérôme Duval			local headers=$headersBase/$gccMachine/include/c++/$gccRawVersion
28966a7f29fSJérôme Duval			if [ ! -d $headers ]; then
29066a7f29fSJérôme Duval				headers=$headersBase/include/c++/$gccRawVersion
29166a7f29fSJérôme Duval			fi
29266a7f29fSJérôme Duval			bootCxxHeaders="$headers/$gccMachine/32"
2934591ebc9SAlex Smith			;;
294338b8dc3SIngo Weinhold	esac
295c0e8cc1aSIngo Weinhold
296c0e8cc1aSIngo Weinhold	# determine whether graphite loop optimization should/can be used
297c0e8cc1aSIngo Weinhold	local useGraphite=`get_variable HAIKU_USE_GCC_GRAPHITE_$targetCpu`
298c0e8cc1aSIngo Weinhold	if [ -z "$useGraphite" ]; then
299c0e8cc1aSIngo Weinhold		useGraphite=$useGccGraphiteDefault
300c0e8cc1aSIngo Weinhold	fi
301c0e8cc1aSIngo Weinhold
302c0e8cc1aSIngo Weinhold	if [ "$useGraphite" != 0 ]; then
303c0e8cc1aSIngo Weinhold		UNUSED=`echo "int main() {}" | $gcc -xc -c -floop-block - 2>&1`
304c0e8cc1aSIngo Weinhold		if [ $? != 0 ]; then
305c0e8cc1aSIngo Weinhold			echo "GCC Graphite loop optimizations cannot be used on $targetArch"
306c0e8cc1aSIngo Weinhold			useGraphite=0
307c0e8cc1aSIngo Weinhold		fi
308c0e8cc1aSIngo Weinhold	fi
309c0e8cc1aSIngo Weinhold
310c0e8cc1aSIngo Weinhold	set_variable HAIKU_CPU_$targetArch $targetCpu
311c0e8cc1aSIngo Weinhold
312c0e8cc1aSIngo Weinhold	get_build_tool_path CC_$targetArch "$gcc"
313c2b76f7fSJonathan Schleifer	if [ $useClang = 1 ]; then
314c2b76f7fSJonathan Schleifer		# The get_build_tool_path above is needed to get the path to the rest
315c2b76f7fSJonathan Schleifer		# of the build tools
316c2b76f7fSJonathan Schleifer		local path=`dirname $(get_variable HAIKU_CC_$targetArch)`
317c2b76f7fSJonathan Schleifer		set_variable HAIKU_CC_$targetArch \
318c2b76f7fSJonathan Schleifer			"PATH=\\\"$path:\\\$PATH\\\" clang -target $gccMachine"
319c2b76f7fSJonathan Schleifer		set_variable HAIKU_CC_IS_CLANG_$targetArch 1
320c2b76f7fSJonathan Schleifer	else
321c2b76f7fSJonathan Schleifer		set_variable HAIKU_CC_IS_CLANG_$targetArch 0
322c2b76f7fSJonathan Schleifer	fi
323c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_RAW_VERSION_$targetArch $gccRawVersion
324c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_MACHINE_$targetArch $gccMachine
325c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_LIB_DIR_$targetArch $gccdir
32666a7f29fSJérôme Duval	set_variable HAIKU_BOOT_CXX_HEADERS_DIR_$targetArch "$bootCxxHeaders"
32711ae3c5fSOliver Tappe	set_variable HAIKU_BOOT_LIBSUPCXX_$targetArch "$bootLibSupCxx"
32811ae3c5fSOliver Tappe	set_variable HAIKU_BOOT_LIBGCC_$targetArch $bootLibgcc
329c0e8cc1aSIngo Weinhold	set_variable HAIKU_USE_GCC_GRAPHITE_$targetArch $useGraphite
330c0e8cc1aSIngo Weinhold
331c0e8cc1aSIngo Weinhold	standard_gcc_settings_targetArch=$targetArch
332c0e8cc1aSIngo Weinhold}
333c0e8cc1aSIngo Weinhold
334c0e8cc1aSIngo Weinhold# set_variable
335c0e8cc1aSIngo Weinhold#
336c0e8cc1aSIngo Weinhold# Set the value of a variable.
337c0e8cc1aSIngo Weinhold#
338c0e8cc1aSIngo Weinholdset_variable()
339c0e8cc1aSIngo Weinhold{
340c0e8cc1aSIngo Weinhold	eval "$1=\"$2\""
341c0e8cc1aSIngo Weinhold}
342c0e8cc1aSIngo Weinhold
343c0e8cc1aSIngo Weinhold# get_variable
344c0e8cc1aSIngo Weinhold#
345c0e8cc1aSIngo Weinhold# Echo the value of a variable.
346c0e8cc1aSIngo Weinhold#
347c0e8cc1aSIngo Weinholdget_variable()
348c0e8cc1aSIngo Weinhold{
349c0e8cc1aSIngo Weinhold	eval "echo \${$1}"
35009c5682dSIngo Weinhold}
35109c5682dSIngo Weinhold
352338b8dc3SIngo Weinhold# set_default_value
353338b8dc3SIngo Weinhold#
354338b8dc3SIngo Weinhold# Set the value for a variable, if no value is set yet.
355338b8dc3SIngo Weinhold#
356338b8dc3SIngo Weinholdset_default_value()
357338b8dc3SIngo Weinhold{
3580838a930SJérôme Duval	eval "$1=\${$1-$2}"
359338b8dc3SIngo Weinhold}
360338b8dc3SIngo Weinhold
361338b8dc3SIngo Weinhold# get_build_tool_path
362338b8dc3SIngo Weinhold#
363338b8dc3SIngo Weinhold# Gets a usable absolute path of a build tool.
364338b8dc3SIngo Weinhold#
365338b8dc3SIngo Weinholdget_build_tool_path()
366338b8dc3SIngo Weinhold{
367338b8dc3SIngo Weinhold	local var="HAIKU_$1"
368c0e8cc1aSIngo Weinhold	local path=$2
369338b8dc3SIngo Weinhold
370338b8dc3SIngo Weinhold	if [ -f "$path" ]; then
371338b8dc3SIngo Weinhold		# get absolute path
372a559f87aSFrançois Revol		local oldPwd="`pwd`"
373a559f87aSFrançois Revol		cd "`dirname "$path"`"
374a559f87aSFrançois Revol		path="`pwd`/`basename "$path"`"
375338b8dc3SIngo Weinhold		cd $oldPwd
376338b8dc3SIngo Weinhold	else
3777fe2e06cSMatt Madia		which "$path" > /dev/null 2>&1 || {
378338b8dc3SIngo Weinhold			echo "Build tool \"$path\" not found." >&2
379338b8dc3SIngo Weinhold			exit 1
380338b8dc3SIngo Weinhold		}
381338b8dc3SIngo Weinhold	fi
382338b8dc3SIngo Weinhold
383338b8dc3SIngo Weinhold	eval "$var=$path"
384338b8dc3SIngo Weinhold}
385338b8dc3SIngo Weinhold
386483b28e4SIngo Weinholdis_in_list()
387483b28e4SIngo Weinhold{
388483b28e4SIngo Weinhold	local element
389483b28e4SIngo Weinhold	for element in $2; do
390483b28e4SIngo Weinhold		if [ "$1" = "$element" ]; then
391483b28e4SIngo Weinhold			return 0
392483b28e4SIngo Weinhold		fi
393483b28e4SIngo Weinhold	done
394483b28e4SIngo Weinhold	return 1
395483b28e4SIngo Weinhold}
396483b28e4SIngo Weinhold
3977f9beaf1SOliver Tappe# check for --help or -h and show usage immediately
3987f9beaf1SOliver Tappeif [ "$1" = "--help" ] || [ "$1" = "-h" ]; then
3998b420c2fSOliver Tappe	usage; exit 0;
4008b420c2fSOliver Tappefi
4018b420c2fSOliver Tappe
4028b420c2fSOliver Tappe
403338b8dc3SIngo Weinhold# get cwd and the source directory
404338b8dc3SIngo WeinholdcurrentDir=`pwd`
4056e7c6fe5SIngo Weinholdcd `dirname "$0"`
406338b8dc3SIngo WeinholdsourceDir=`pwd`
4076e7c6fe5SIngo Weinholdcd "$currentDir"
408338b8dc3SIngo Weinhold
40955d267a4SFrançois Revol# backup the passed arguments
41055d267a4SFrançois RevolconfigureArgs="$@"
41155d267a4SFrançois Revol
4127c4641d0SOliver Tappe# internal default parameter values
413022fa244SIngo Weinhold#
41452a38012Sejakowatzplatform=`uname`
4155abd9a46SIngo WeinholdplatformMachine=`uname  -m`
416c0e8cc1aSIngo WeinholdtargetArchs=
417338b8dc3SIngo WeinholdbuildCrossTools=
41829ef597dSIngo WeinholdbuildCrossToolsScript="$sourceDir/build/scripts/build_cross_tools"
41960d8d8fcSIngo WeinholdbuildCrossToolsJobs=
420c2b76f7fSJonathan SchleiferuseClang=0
421c0e8cc1aSIngo WeinholduseGccGraphiteDefault=0
422c0e8cc1aSIngo WeinholdunknownArchIndex=1
423483b28e4SIngo WeinholdhaikuTargetArchs=
4247c4641d0SOliver Tappe
42563701e7dSOliver Tappeif [ -z "$CC" ]; then
42663701e7dSOliver Tappe	CC=gcc
42763701e7dSOliver Tappefi
42863701e7dSOliver Tappe
4297c4641d0SOliver Tappe# exported (BuildSetup) default parameter values
4307c4641d0SOliver Tappe#
43163701e7dSOliver TappeHOST_GCC_RAW_VERSION=`$CC -dumpversion`
43263701e7dSOliver TappeHOST_GCC_MACHINE=`$CC -dumpmachine`
4337c4641d0SOliver TappeHAIKU_INCLUDE_GPL_ADDONS=0
4347c4641d0SOliver TappeHAIKU_INCLUDE_PATENTED_CODE=0
43576fa0be3SIngo WeinholdHAIKU_INCLUDE_SOURCES=0
4367c4641d0SOliver TappeHAIKU_INCLUDE_3RDPARTY=0
4377c4641d0SOliver TappeHAIKU_ENABLE_MULTIUSER=0
4387c4641d0SOliver TappeHAIKU_DISTRO_COMPATIBILITY=default
4397c4641d0SOliver TappeTARGET_PLATFORM=haiku
4407c4641d0SOliver TappeHAIKU_USE_GCC_PIPE=0
4417986925fSIngo WeinholdHAIKU_HOST_USE_32BIT=0
4427986925fSIngo WeinholdHAIKU_HOST_USE_XATTR=0
443bc96e8f3SIngo WeinholdHAIKU_HOST_USE_XATTR_REF=0
4442ebcd86dSIngo WeinholdHAIKU_HOST_BUILD_ONLY=0
445f04f7042SNiels Sascha ReedijkHOST_EXTENDED_REGEX_SED="sed -r"
44663701e7dSOliver TappeHOST_GCC_LD=`$CC -print-prog-name=ld`
44763701e7dSOliver TappeHOST_GCC_OBJCOPY=`$CC -print-prog-name=objcopy`
4482a5d0aafSIngo WeinholdHOST_SHA256=
449e173a1ecSIngo WeinholdHOST_HAIKU_PORTER=
450e173a1ecSIngo WeinholdHAIKU_PORTS=
451e173a1ecSIngo WeinholdHAIKU_PORTS_CROSS=
452c9dd05ffSJonathan SchleiferHAIKU_IS_BOOTSTRAP=0
453e70c4c64SPulkoMandyHAIKU_BOOT_BOARD=
454aa2e5ecaSOliver TappeHAIKU_NO_DOWNLOADS=0
4552a5d0aafSIngo Weinhold
456c0e8cc1aSIngo WeinholdHAIKU_PACKAGING_ARCHS=
457c0e8cc1aSIngo Weinhold
458a04a520bSJonathan Schleiferset_default_value HAIKU_NASM		nasm
459c0e8cc1aSIngo Weinhold
4603942ca0dSIngo Weinholdif sha256sum < /dev/null > /dev/null 2>&1; then
4612a5d0aafSIngo Weinhold	HOST_SHA256=sha256sum
4623942ca0dSIngo Weinholdelif sha256 < /dev/null > /dev/null 2>&1; then
4632a5d0aafSIngo Weinhold	HOST_SHA256="sha256 -q"
464b5a871b1SNiels Sascha Reedijkelif shasum < /dev/null > /dev/null 2>&1; then
465b5a871b1SNiels Sascha Reedijk	HOST_SHA256="shasum -a 256"
4662a5d0aafSIngo Weinholdelse
4672a5d0aafSIngo Weinhold	echo "Error: Neither sha256sum nor sha256 seem to be available!" >&2
4682a5d0aafSIngo Weinhold	exit 1
4692a5d0aafSIngo Weinholdfi
470338b8dc3SIngo Weinhold
471410d94cfSOliver TappehaikuRequiredLegacyGCCVersion="2.95.3-haiku-2014_07_26"
472a559f87aSFrançois Revolexport haikuRequiredLegacyGCCVersion
473af4bf973SOliver Tappe	# version of legacy gcc required to build haiku
474483b28e4SIngo WeinholdsupportedTargetArchs="
475483b28e4SIngo Weinhold	arm
476483b28e4SIngo Weinhold	m68k
477483b28e4SIngo Weinhold	ppc
478483b28e4SIngo Weinhold	x86
479483b28e4SIngo Weinhold	x86_64
480483b28e4SIngo Weinhold	x86_gcc2
481483b28e4SIngo Weinhold	"
482e70c4c64SPulkoMandysupportedTargetBoards="
483e70c4c64SPulkoMandy	beagle
484427d40adSAlexander von Gluck IV	rpi1
485427d40adSAlexander von Gluck IV	rpi2
4869c5e234cSAlexander von Gluck IV	cubieboard4
487e70c4c64SPulkoMandy	verdex
48887236c4fSAlexander von Gluck IV	overo
489e70c4c64SPulkoMandy	"
490af4bf973SOliver Tappe
4917c4641d0SOliver Tappe# determine output directory
4927c4641d0SOliver Tappeif [ "$currentDir" = "$sourceDir" ]; then
4937c4641d0SOliver Tappe	outputDir=$currentDir/generated
4947c4641d0SOliver Tappeelse
4957c4641d0SOliver Tappe	outputDir=$currentDir
4967c4641d0SOliver Tappefi
4977c4641d0SOliver TappebuildOutputDir="$outputDir/build"
4987c4641d0SOliver TappeHAIKU_BUILD_ATTRIBUTES_DIR="$outputDir/attributes"
4997c4641d0SOliver TappebuildConfigFile="$buildOutputDir/BuildConfig"
5007c4641d0SOliver Tappe
5017c4641d0SOliver Tappe# check for update request
5027c4641d0SOliver Tappeif [ "$1" = "--update" ]; then
5037c4641d0SOliver Tappe	if ! [ -e "$buildConfigFile" ]; then
5047c4641d0SOliver Tappe		echo $0 --update: \'$buildConfigFile\' not found - updating not possible.
5057c4641d0SOliver Tappe		exit 1
5067c4641d0SOliver Tappe	fi
5077c4641d0SOliver Tappe	if ! type perl >/dev/null 2>&1; then
5087c4641d0SOliver Tappe		echo $0 --update: \'perl\' not found - updating not possible.
5097c4641d0SOliver Tappe		exit 1
5107c4641d0SOliver Tappe	fi
5117c4641d0SOliver Tappe	# convert BuildConfig from jam format to shell format and evaluate it
5127c4641d0SOliver Tappe	shellConfigFile="${buildConfigFile}.shell"
5137c4641d0SOliver Tappe	perl "$sourceDir/build/scripts/convert_build_config_to_shell_format.pl" \
5147c4641d0SOliver Tappe		<"$buildConfigFile" >"$shellConfigFile"
5157c4641d0SOliver Tappe	. "$shellConfigFile"
5167c4641d0SOliver Tappe	rm "$shellConfigFile"
5177c4641d0SOliver Tappe	shift
5187c4641d0SOliver Tappefi
5197c4641d0SOliver Tappe
520022fa244SIngo Weinhold# parse parameters
521022fa244SIngo Weinhold#
52220ab75e6SIngo Weinholdwhile [ $# -gt 0 ] ; do
523022fa244SIngo Weinhold	case "$1" in
524e173a1ecSIngo Weinhold		--bootstrap)
525e173a1ecSIngo Weinhold			assertparams "$1" 3 $#
526e173a1ecSIngo Weinhold			HOST_HAIKU_PORTER="`absolute_path $2`"
527e173a1ecSIngo Weinhold			HAIKU_PORTS_CROSS="`absolute_path $3`"
528e173a1ecSIngo Weinhold			HAIKU_PORTS="`absolute_path $4`"
529c9dd05ffSJonathan Schleifer			HAIKU_IS_BOOTSTRAP=1
530c9dd05ffSJonathan Schleifer			HAIKU_NO_DOWNLOADS=1
531502882dbSJessica Hamilton			check_file_exists "$HOST_HAIKU_PORTER" || (
532502882dbSJessica Hamilton				echo "Invalid path to haikuporter: $HOST_HAIKU_PORTER" >&2
53339d444a3SArvind S Raj				exit 1
53439d444a3SArvind S Raj			)
53539d444a3SArvind S Raj			check_dir_exists "$HAIKU_PORTS" || (
53639d444a3SArvind S Raj				echo "Non-existent directory $HAIKU_PORTS" >&2
53739d444a3SArvind S Raj				exit 1
53839d444a3SArvind S Raj			)
53939d444a3SArvind S Raj			check_dir_exists "$HAIKU_PORTS_CROSS" || (
54039d444a3SArvind S Raj				echo "Non-existent directory $HAIKU_PORTS_CROSS" >&2
54139d444a3SArvind S Raj				exit 1
54239d444a3SArvind S Raj			)
543e173a1ecSIngo Weinhold			shift 4
544e173a1ecSIngo Weinhold			;;
545c0e8cc1aSIngo Weinhold		--build-cross-tools)
546c0e8cc1aSIngo Weinhold			if [ -z "$buildCrossTools" ]; then
5479b0dd528SIngo Weinhold				assertparams "$1" 2 $#
548c0e8cc1aSIngo Weinhold				targetArch=$2
5499b0dd528SIngo Weinhold				buildCrossTools=$3
5509b0dd528SIngo Weinhold				shift 3
551c0e8cc1aSIngo Weinhold			else
552c0e8cc1aSIngo Weinhold				assertparam "$1" $#
553c0e8cc1aSIngo Weinhold				targetArch=$2
554c0e8cc1aSIngo Weinhold				shift 2
555c0e8cc1aSIngo Weinhold			fi
556c0e8cc1aSIngo Weinhold			case "$targetArch" in
557c0e8cc1aSIngo Weinhold				x86_gcc2)	targetMachine=i586-pc-haiku;;
558c0e8cc1aSIngo Weinhold				x86)		targetMachine=i586-pc-haiku;;
559c0e8cc1aSIngo Weinhold				x86_64)		targetMachine=x86_64-unknown-haiku;;
560c0e8cc1aSIngo Weinhold				ppc)		targetMachine=powerpc-apple-haiku;;
561c0e8cc1aSIngo Weinhold				m68k)		targetMachine=m68k-unknown-haiku;;
562c0e8cc1aSIngo Weinhold				arm)		targetMachine=arm-unknown-haiku;;
563c0e8cc1aSIngo Weinhold				*)
564c0e8cc1aSIngo Weinhold					echo "Unsupported target architecture: $2" >&2
565c0e8cc1aSIngo Weinhold					exit 1
566c0e8cc1aSIngo Weinhold					;;
567c0e8cc1aSIngo Weinhold			esac
568c0e8cc1aSIngo Weinhold			set_variable buildCrossToolsMachine_$targetArch $targetMachine
569c0e8cc1aSIngo Weinhold			targetArchs="$targetArchs $targetArch"
570c0e8cc1aSIngo Weinhold			HAIKU_PACKAGING_ARCHS=
5719b0dd528SIngo Weinhold			;;
5729b0dd528SIngo Weinhold		--cross-tools-prefix)
5739b0dd528SIngo Weinhold			assertparam "$1" $#
574c0e8cc1aSIngo Weinhold			targetArch=unknown${unknownArchIndex}
575c0e8cc1aSIngo Weinhold			set_variable crossToolsPrefix_$targetArch "$2"
576c0e8cc1aSIngo Weinhold			targetArchs="$targetArchs $targetArch"
577c0e8cc1aSIngo Weinhold			HAIKU_PACKAGING_ARCHS=
578d68208faSMatt Madia			unknownArchIndex=$(($unknownArchIndex + 1))
5799b0dd528SIngo Weinhold			shift 2
5809b0dd528SIngo Weinhold			;;
581a66c32ddSIngo Weinhold		--distro-compatibility)
5829b0dd528SIngo Weinhold			assertparam "$1" $#
5837c4641d0SOliver Tappe			HAIKU_DISTRO_COMPATIBILITY=$2
5847c4641d0SOliver Tappe			case "$HAIKU_DISTRO_COMPATIBILITY" in
585a66c32ddSIngo Weinhold				official)	;;
586a66c32ddSIngo Weinhold				compatible)	;;
587a66c32ddSIngo Weinhold				default)	;;
588a66c32ddSIngo Weinhold				*)			echo "Invalid distro compatibility" \
5897c4641d0SOliver Tappe								"level: $HAIKU_DISTRO_COMPATIBILITY"
590a66c32ddSIngo Weinhold							exit 1;;
591a66c32ddSIngo Weinhold			esac
5929b0dd528SIngo Weinhold			shift 2
5939b0dd528SIngo Weinhold			;;
5947c4641d0SOliver Tappe		--enable-multiuser)	HAIKU_ENABLE_MULTIUSER=1; shift 1;;
5952ebcd86dSIngo Weinhold		--host-only)	HAIKU_HOST_BUILD_ONLY=1; shift 1;;
5967c4641d0SOliver Tappe		--include-gpl-addons)	HAIKU_INCLUDE_GPL_ADDONS=1; shift 1;;
5977c4641d0SOliver Tappe		--include-patented-code)	HAIKU_INCLUDE_PATENTED_CODE=1; shift 1;;
59876fa0be3SIngo Weinhold		--include-sources)	HAIKU_INCLUDE_SOURCES=1; shift 1;;
5997c4641d0SOliver Tappe		--include-3rdparty)	HAIKU_INCLUDE_3RDPARTY=1; shift 1;;
60060d8d8fcSIngo Weinhold        -j*)				buildCrossToolsJobs="$1"; shift 1;;
601aa2e5ecaSOliver Tappe		--no-downloads)	HAIKU_NO_DOWNLOADS=1; shift 1;;
6027c4641d0SOliver Tappe		--target=*)     TARGET_PLATFORM=`echo $1 | cut -d'=' -f2-`; shift 1;;
603483b28e4SIngo Weinhold		--target-arch)
604483b28e4SIngo Weinhold			assertparam "$1" $#
605483b28e4SIngo Weinhold			targetArch=$2
606483b28e4SIngo Weinhold			shift 2
607483b28e4SIngo Weinhold			if [ ! "$platform" = Haiku ]; then
608483b28e4SIngo Weinhold				echo "--target-arch can only be specified on Haiku." >&2
609483b28e4SIngo Weinhold				exit 1
610483b28e4SIngo Weinhold			fi
611483b28e4SIngo Weinhold			is_in_list "$targetArch" "$supportedTargetArchs" || (
612483b28e4SIngo Weinhold				echo "Unsupported target architecture: \"$targetArch\"" >&2
613483b28e4SIngo Weinhold				exit 1
614483b28e4SIngo Weinhold			)
615483b28e4SIngo Weinhold			haikuTargetArchs="$haikuTargetArchs $targetArch"
616483b28e4SIngo Weinhold			;;
617e70c4c64SPulkoMandy		--target-board)
618e70c4c64SPulkoMandy			assertparam "$1" $#
619e70c4c64SPulkoMandy			HAIKU_BOOT_BOARD=$2
620e70c4c64SPulkoMandy			is_in_list "$HAIKU_BOOT_BOARD" "$supportedTargetBoards" || (
621e70c4c64SPulkoMandy				echo "Unsupported target board: \"$HAIKU_BOOT_BOARD\"" >&2
622e70c4c64SPulkoMandy				exit 1
623e70c4c64SPulkoMandy			)
624e70c4c64SPulkoMandy			shift 2
625e70c4c64SPulkoMandy			;;
626c2b76f7fSJonathan Schleifer		--use-clang) useClang=1; shift 1;;
6277c4641d0SOliver Tappe		--use-gcc-pipe)	HAIKU_USE_GCC_PIPE=1; shift 1;;
628c0e8cc1aSIngo Weinhold		--use-gcc-graphite)	useGccGraphiteDefault=1; shift 1;;
6297986925fSIngo Weinhold		--use-32bit)	HAIKU_HOST_USE_32BIT=1; shift 1;;
6307986925fSIngo Weinhold		--use-xattr)	HAIKU_HOST_USE_XATTR=1; shift 1;;
631bc96e8f3SIngo Weinhold		--use-xattr-ref)	HAIKU_HOST_USE_XATTR_REF=1; shift 1;;
632022fa244SIngo Weinhold		*)				echo Invalid argument: \`$1\'; exit 1;;
633022fa244SIngo Weinhold	esac
634022fa244SIngo Weinholddone
635022fa244SIngo Weinhold
6360df3cc9cSIngo Weinhold# detect the build platform
637338b8dc3SIngo Weinholdcase "${platform}" in
6387c4641d0SOliver Tappe	Darwin)	HOST_PLATFORM=darwin ;;
6397c4641d0SOliver Tappe	FreeBSD)	HOST_PLATFORM=freebsd
6407986925fSIngo Weinhold				if [ "$HAIKU_HOST_USE_32BIT" = 1 ] ; then
6415abd9a46SIngo Weinhold					echo Unsupported platform: FreeBSD ${platformMachine}
642308c212cSIngo Weinhold					exit 1
643308c212cSIngo Weinhold				fi	;;
6447c4641d0SOliver Tappe	Haiku)	HOST_PLATFORM=haiku_host ;;
6457c4641d0SOliver Tappe	Linux)	HOST_PLATFORM=linux ;;
6467c4641d0SOliver Tappe	OpenBSD) HOST_PLATFORM=openbsd ;;
6477c4641d0SOliver Tappe	SunOS)	HOST_PLATFORM=sunos ;;
6487c4641d0SOliver Tappe	CYGWIN_NT-*) HOST_PLATFORM=cygwin ;;
649338b8dc3SIngo Weinhold	*)		echo Unsupported platform: ${platform}
6504cbe4925SAxel Dörfler			exit 1 ;;
6514cbe4925SAxel Dörfleresac
65252a38012Sejakowatz
6530962132cSAlex Smith# check for case-sensitive filesystem
6540962132cSAlex Smithmkdir haikuCaseTest 2>/dev/null
6550962132cSAlex Smithmkdir haikucasetest 2>/dev/null
6560962132cSAlex SmithcaseInsensitive=$?
65797f5a0bdSAlex Smithrmdir haikuCaseTest haikucasetest 2>/dev/null
6580962132cSAlex Smithif [ $caseInsensitive != 0 ]; then
6593ecc5287SMichael Lotz	echo "You need a case-sensitive file-system to build Haiku."
6600962132cSAlex Smith	if [ $HOST_PLATFORM = "darwin" ]; then
6610962132cSAlex Smith		echo "You can create a case-sensitive disk image using Disk Utility and use"
6620962132cSAlex Smith		echo "it to store the Haiku sources on."
6633ecc5287SMichael Lotz	fi
6640962132cSAlex Smith	exit 1
6653ecc5287SMichael Lotzfi
6663ecc5287SMichael Lotz
667f04f7042SNiels Sascha Reedijk# determine how to invoke sed with extended regexp support for non-GNU sed
668f04f7042SNiels Sascha Reedijkif [ $HOST_PLATFORM = "darwin" ]; then
669f04f7042SNiels Sascha Reedijk	HOST_EXTENDED_REGEX_SED="sed -E"
670f04f7042SNiels Sascha Reedijkfi
671f04f7042SNiels Sascha Reedijk
672cb721c59SFrançois Revol# check if nasm can actually output ELF files
673cb721c59SFrançois Revol# (the stock version in OSX can't)
674cb721c59SFrançois Revol# XXX: should probably only test for x86* arch
6753e6c09cdSAdrien Destuguesif [ "$("$HAIKU_NASM" -hf | grep -c elf'[36][24] ')" -ne "2" ]; then
676cb721c59SFrançois Revol	echo "$HAIKU_NASM cannot generate ELF files. Please install a working version."
677cb721c59SFrançois Revol	if [ $HOST_PLATFORM = "darwin" ]; then
678cb721c59SFrançois Revol		echo "You can install it from Mac Ports."
679cb721c59SFrançois Revol		echo "Mac Ports is available at: http://www.macports.org/"
680cb721c59SFrançois Revol	fi
681cb721c59SFrançois Revol	exit 1
682cb721c59SFrançois Revolfi
683cb721c59SFrançois Revol
684338b8dc3SIngo Weinhold# create output directory
6856e7c6fe5SIngo Weinholdmkdir -p "$buildOutputDir" || exit 1
686338b8dc3SIngo Weinhold
6872ebcd86dSIngo Weinholdif [ "$HAIKU_HOST_BUILD_ONLY" = 1 ]; then
6882ebcd86dSIngo Weinhold	invalidCommand=$sourceDir/build/scripts/host_build_only
6892ebcd86dSIngo Weinhold	HAIKU_AR=$invalidCommand
6902ebcd86dSIngo Weinhold	HAIKU_CC=$invalidCommand
6912ebcd86dSIngo Weinhold	HAIKU_LD=$invalidCommand
6922ebcd86dSIngo Weinhold	HAIKU_OBJCOPY=$invalidCommand
6932ebcd86dSIngo Weinhold	HAIKU_RANLIB=$invalidCommand
6942ebcd86dSIngo Weinhold	HAIKU_ELFEDIT=$invalidCommand
695d6f80927SJonathan Schleifer	HAIKU_NASM=$invalidCommand
6962ebcd86dSIngo Weinhold	HAIKU_STRIP=$invalidCommand
6972ebcd86dSIngo Weinholdelse
698c0e8cc1aSIngo Weinhold	if [ -n "$HAIKU_PACKAGING_ARCHS" ]; then
699c0e8cc1aSIngo Weinhold		targetArchs="$HAIKU_PACKAGING_ARCHS"
700c0e8cc1aSIngo Weinhold	fi
701c0e8cc1aSIngo Weinhold	HAIKU_PACKAGING_ARCHS=
702c0e8cc1aSIngo Weinhold
703483b28e4SIngo Weinhold	# On Haiku determine target architectures and tools automatically.
704c0e8cc1aSIngo Weinhold	if [ -z "$targetArchs" ]; then
705483b28e4SIngo Weinhold		if [ $HOST_PLATFORM != haiku_host ]; then
706483b28e4SIngo Weinhold			echo "Please specify the build tools to use or build (via" \
707eaef83a9SJeroen Oortwijn				"--cross-tools-prefix or --build-cross-tools) or specify a" \
708483b28e4SIngo Weinhold				"host-only build (--host-only)." >&2
7097f9beaf1SOliver Tappe			echo "For more info, invoke $0 --help"
710483b28e4SIngo Weinhold			exit 1
711483b28e4SIngo Weinhold		fi
712483b28e4SIngo Weinhold
713483b28e4SIngo Weinhold		# determine primary architecture
714dda53eaeSIngo Weinhold		targetArch=`package list -i /system/packages/haiku-*.hpkg \
715483b28e4SIngo Weinhold			| sed '/^\s*architecture:/!d; s,^\s*architecture:\s*,,'`
716483b28e4SIngo Weinhold		is_in_list "$targetArch" "$supportedTargetArchs" || (
717483b28e4SIngo Weinhold			echo "Unsupported target architecture: \"$targetArch\"" >&2
718483b28e4SIngo Weinhold			exit 1
719483b28e4SIngo Weinhold		)
720c0e8cc1aSIngo Weinhold		targetArchs=$targetArch
721483b28e4SIngo Weinhold
722c0e8cc1aSIngo Weinhold		set_default_value HAIKU_AR_$targetArch			ar
723c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CC_$targetArch			gcc
724c0e8cc1aSIngo Weinhold		set_default_value HAIKU_LD_$targetArch			ld
725c0e8cc1aSIngo Weinhold		set_default_value HAIKU_OBJCOPY_$targetArch		objcopy
726c0e8cc1aSIngo Weinhold		set_default_value HAIKU_RANLIB_$targetArch		ranlib
727c0e8cc1aSIngo Weinhold		set_default_value HAIKU_ELFEDIT_$targetArch		elfedit
728c0e8cc1aSIngo Weinhold		set_default_value HAIKU_STRIP_$targetArch		strip
729483b28e4SIngo Weinhold
730483b28e4SIngo Weinhold		# determine secondary architectures
731483b28e4SIngo Weinhold		for targetArch in $supportedTargetArchs; do
73280262a91SMatt Madia			if [ -e /system/packages/haiku_$targetArch-*.hpkg ]; then
733483b28e4SIngo Weinhold				targetArchs="$targetArchs $targetArch"
734483b28e4SIngo Weinhold				set_default_value HAIKU_AR_$targetArch		ar-$targetArch
735483b28e4SIngo Weinhold				set_default_value HAIKU_CC_$targetArch		gcc-$targetArch
736483b28e4SIngo Weinhold				set_default_value HAIKU_LD_$targetArch		ld-$targetArch
737483b28e4SIngo Weinhold				set_default_value HAIKU_OBJCOPY_$targetArch	objcopy-$targetArch
738483b28e4SIngo Weinhold				set_default_value HAIKU_RANLIB_$targetArch	ranlib-$targetArch
739483b28e4SIngo Weinhold				set_default_value HAIKU_ELFEDIT_$targetArch	elfedit-$targetArch
740483b28e4SIngo Weinhold				set_default_value HAIKU_STRIP_$targetArch	strip-$targetArch
741483b28e4SIngo Weinhold			fi
742483b28e4SIngo Weinhold		done
743483b28e4SIngo Weinhold
744483b28e4SIngo Weinhold		# The target architectures might have been specified explicitly.
745483b28e4SIngo Weinhold		if [ -n "$haikuTargetArchs" ]; then
746483b28e4SIngo Weinhold			for targetArch in $haikuTargetArchs; do
747483b28e4SIngo Weinhold				is_in_list "$targetArch" "$targetArchs" || (
748483b28e4SIngo Weinhold					echo "Unsupported target architecture: \"$targetArch\"." \
749483b28e4SIngo Weinhold						"Only native architectures of the host platform can" \
750483b28e4SIngo Weinhold						"be specified." >&2
751483b28e4SIngo Weinhold					exit 1
752483b28e4SIngo Weinhold				)
753483b28e4SIngo Weinhold			done
754483b28e4SIngo Weinhold			targetArchs="$haikuTargetArchs"
755483b28e4SIngo Weinhold		fi
756c0e8cc1aSIngo Weinhold	fi
757c0e8cc1aSIngo Weinhold
75868ccc989SIngo Weinhold	isPrimaryArch=1
759c0e8cc1aSIngo Weinhold	for targetArch in $targetArchs; do
760c0e8cc1aSIngo Weinhold		# Note: targetArch is "unknown<n>" at this point, if a cross-tools
761c0e8cc1aSIngo Weinhold		# prefix was specified. The standard_gcc_settings call below will get
762c0e8cc1aSIngo Weinhold		# the actual architecture.
763c0e8cc1aSIngo Weinhold
764c0e8cc1aSIngo Weinhold		crossToolsPrefix=`get_variable crossToolsPrefix_$targetArch`
765c0e8cc1aSIngo Weinhold
766338b8dc3SIngo Weinhold		# build cross tools from sources
767c0e8cc1aSIngo Weinhold		if [ -n "$buildCrossTools" -a -z "$crossToolsPrefix" ]; then
768c0e8cc1aSIngo Weinhold			crossToolsDir="$outputDir/cross-tools-$targetArch"
769c0e8cc1aSIngo Weinhold			targetMachine=`get_variable buildCrossToolsMachine_$targetArch`
770c0e8cc1aSIngo Weinhold			script="$buildCrossToolsScript"
7718304ec7cSIngo Weinhold			scriptArgs=
772c0e8cc1aSIngo Weinhold			if [ $targetArch != x86_gcc2 ]; then
7738304ec7cSIngo Weinhold				script="${script}_gcc4"
7748304ec7cSIngo Weinhold				scriptArgs="$targetMachine"
7751e93288eSJérôme Duval				set_default_value HAIKU_USE_GCC_GRAPHITE_$targetArch	\
7761e93288eSJérôme Duval					$useGccGraphiteDefault
777c0e8cc1aSIngo Weinhold			fi
77868ccc989SIngo Weinhold			secondaryArch=
77968ccc989SIngo Weinhold			if [ -z "$isPrimaryArch" ]; then
78068ccc989SIngo Weinhold				secondaryArch=$targetArch
78168ccc989SIngo Weinhold			fi
78286de8c37SIngo Weinhold
78386de8c37SIngo Weinhold			case $HOST_PLATFORM in
78486de8c37SIngo Weinhold				freebsd|openbsd)	MAKE=gmake;;
78586de8c37SIngo Weinhold				*)					MAKE=make;;
78686de8c37SIngo Weinhold			esac
78786de8c37SIngo Weinhold
78886de8c37SIngo Weinhold			MAKE=$MAKE \
78968ccc989SIngo Weinhold			SECONDARY_ARCH=$secondaryArch \
790c0e8cc1aSIngo Weinhold			HAIKU_USE_GCC_GRAPHITE=`get_variable \
791c0e8cc1aSIngo Weinhold				HAIKU_USE_GCC_GRAPHITE_$targetArch` \
792b3ece905SJérôme Duval			HAIKU_USE_GCC_PIPE=$HAIKU_USE_GCC_PIPE \
7938304ec7cSIngo Weinhold			"$script" $scriptArgs "$sourceDir" "$buildCrossTools" \
7948304ec7cSIngo Weinhold				"$crossToolsDir" $buildCrossToolsJobs || exit 1
795c0e8cc1aSIngo Weinhold			crossToolsPrefix="$crossToolsDir/bin/${targetMachine}-"
796338b8dc3SIngo Weinhold		fi
797338b8dc3SIngo Weinhold
798c0e8cc1aSIngo Weinhold		# prepare gcc settings and get the actual target architecture
799c0e8cc1aSIngo Weinhold		gcc="${crossToolsPrefix}gcc"
800c0e8cc1aSIngo Weinhold		if [ -z "${crossToolsPrefix}" ]; then
801c0e8cc1aSIngo Weinhold			gcc=`get_variable HAIKU_CC_$targetArch`
802338b8dc3SIngo Weinhold		fi
803c0e8cc1aSIngo Weinhold		standard_gcc_settings "$gcc"
804c0e8cc1aSIngo Weinhold		targetArch=$standard_gcc_settings_targetArch
805338b8dc3SIngo Weinhold
806c0e8cc1aSIngo Weinhold		# set default values for flags
807c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CPPFLAGS_$targetArch	""
808c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CCFLAGS_$targetArch		""
809c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CXXFLAGS_$targetArch	""
810c0e8cc1aSIngo Weinhold		set_default_value HAIKU_LDFLAGS_$targetArch		""
811c0e8cc1aSIngo Weinhold		set_default_value HAIKU_ARFLAGS_$targetArch		cru
812c0e8cc1aSIngo Weinhold		set_default_value HAIKU_UNARFLAGS_$targetArch	x
813338b8dc3SIngo Weinhold
814c0e8cc1aSIngo Weinhold		# Override the cross tools variables, if the tools were built or a
815c0e8cc1aSIngo Weinhold		# prefix was specified.
816b7777272SAlex Smith		if [ -n "$crossToolsPrefix" ]; then
817c0e8cc1aSIngo Weinhold			get_build_tool_path AR_$targetArch ${crossToolsPrefix}ar
818c0e8cc1aSIngo Weinhold			get_build_tool_path LD_$targetArch ${crossToolsPrefix}ld
819c0e8cc1aSIngo Weinhold			get_build_tool_path OBJCOPY_$targetArch ${crossToolsPrefix}objcopy
820c0e8cc1aSIngo Weinhold			get_build_tool_path RANLIB_$targetArch ${crossToolsPrefix}ranlib
821c0e8cc1aSIngo Weinhold			get_build_tool_path STRIP_$targetArch ${crossToolsPrefix}strip
822c0e8cc1aSIngo Weinhold
823c0e8cc1aSIngo Weinhold			case `get_variable HAIKU_GCC_RAW_VERSION_$targetArch` in
824*94887febSJérôme Duval				4.*|5.*|6.*)
825c0e8cc1aSIngo Weinhold					get_build_tool_path ELFEDIT_$targetArch \
826c0e8cc1aSIngo Weinhold						${crossToolsPrefix}elfedit
827bd16f0ddSAlex Smith				;;
828bd16f0ddSAlex Smith			esac
82952a38012Sejakowatz		fi
83052a38012Sejakowatz
831ef57df3dSIngo Weinhold		# check whether the Haiku compiler really targets Haiku
832c0e8cc1aSIngo Weinhold		targetMachine=`get_variable HAIKU_GCC_MACHINE_$targetArch`
833c0e8cc1aSIngo Weinhold		case "$targetMachine" in
834eedc3d0bSIngo Weinhold			*-*-haiku)	;;
835c0e8cc1aSIngo Weinhold			*)
836c0e8cc1aSIngo Weinhold				echo The compiler specified as Haiku target compiler is not a \
837c0e8cc1aSIngo Weinhold				valid Haiku cross-compiler. Please see ReadMe.cross-compile. >&2
838eedc3d0bSIngo Weinhold				echo compiler: $HAIKU_CC
839c0e8cc1aSIngo Weinhold				echo compiler is configured for target: $targetMachine
840eedc3d0bSIngo Weinhold				exit 1 ;;
841eedc3d0bSIngo Weinhold		esac
842c0e8cc1aSIngo Weinhold
843c0e8cc1aSIngo Weinhold		HAIKU_PACKAGING_ARCHS="$HAIKU_PACKAGING_ARCHS $targetArch"
84468ccc989SIngo Weinhold		isPrimaryArch=
845c0e8cc1aSIngo Weinhold	done
8462ebcd86dSIngo Weinholdfi
847eedc3d0bSIngo Weinhold
84852a38012Sejakowatz# Generate BuildConfig
8497c4641d0SOliver Tappecat << EOF > "$buildConfigFile"
85052a38012Sejakowatz# BuildConfig
851ab2540c4SIngo Weinhold# Note: This file has been automatically generated by configure with the
852ab2540c4SIngo Weinhold# following arguments:
85355d267a4SFrançois Revol# ${configureArgs}
85452a38012Sejakowatz
8557c4641d0SOliver TappeTARGET_PLATFORM 			?= "${TARGET_PLATFORM}" ;
8567c4641d0SOliver TappeHOST_PLATFORM				?= "${HOST_PLATFORM}" ;
857338b8dc3SIngo Weinhold
8587c4641d0SOliver TappeHAIKU_INCLUDE_GPL_ADDONS			?= "${HAIKU_INCLUDE_GPL_ADDONS}" ;
8597c4641d0SOliver TappeHAIKU_INCLUDE_PATENTED_CODE			?= "${HAIKU_INCLUDE_PATENTED_CODE}" ;
86076fa0be3SIngo WeinholdHAIKU_INCLUDE_SOURCES				?= "${HAIKU_INCLUDE_SOURCES}" ;
8617c4641d0SOliver TappeHAIKU_INCLUDE_3RDPARTY				?= "${HAIKU_INCLUDE_3RDPARTY}" ;
8627c4641d0SOliver TappeHAIKU_ENABLE_MULTIUSER				?= "${HAIKU_ENABLE_MULTIUSER}" ;
8637c4641d0SOliver TappeHAIKU_DISTRO_COMPATIBILITY			?= "${HAIKU_DISTRO_COMPATIBILITY}" ;
8647c4641d0SOliver TappeHAIKU_USE_GCC_PIPE					?= "${HAIKU_USE_GCC_PIPE}" ;
8657986925fSIngo WeinholdHAIKU_HOST_USE_32BIT				?= "${HAIKU_HOST_USE_32BIT}" ;
8667986925fSIngo WeinholdHAIKU_HOST_USE_XATTR				?= "${HAIKU_HOST_USE_XATTR}" ;
867bc96e8f3SIngo WeinholdHAIKU_HOST_USE_XATTR_REF			?= "${HAIKU_HOST_USE_XATTR_REF}" ;
8682ebcd86dSIngo WeinholdHAIKU_HOST_BUILD_ONLY				?= "${HAIKU_HOST_BUILD_ONLY}" ;
869eccc7665SIngo Weinhold
870c0e8cc1aSIngo WeinholdHAIKU_PACKAGING_ARCHS		?= ${HAIKU_PACKAGING_ARCHS} ;
87165ad1ba3SAlex Smith
872aa2e5ecaSOliver TappeHAIKU_NO_DOWNLOADS			?= "${HAIKU_NO_DOWNLOADS}" ;
873aa2e5ecaSOliver Tappe
8747c4641d0SOliver TappeHAIKU_BUILD_ATTRIBUTES_DIR	?= ${HAIKU_BUILD_ATTRIBUTES_DIR} ;
875338b8dc3SIngo Weinhold
876d6f80927SJonathan SchleiferHAIKU_NASM					?= ${HAIKU_NASM} ;
877e70c4c64SPulkoMandyHAIKU_BOOT_BOARD			?= ${HAIKU_BOOT_BOARD} ;
878338b8dc3SIngo Weinhold
879f04f7042SNiels Sascha ReedijkHOST_EXTENDED_REGEX_SED		?= ${HOST_EXTENDED_REGEX_SED} ;
8807c4641d0SOliver TappeHOST_GCC_RAW_VERSION		?= ${HOST_GCC_RAW_VERSION} ;
8817c4641d0SOliver TappeHOST_GCC_MACHINE			?= ${HOST_GCC_MACHINE} ;
8827c4641d0SOliver TappeHOST_LD						?= ${HOST_GCC_LD} ;
8837c4641d0SOliver TappeHOST_OBJCOPY				?= ${HOST_GCC_OBJCOPY} ;
8842a5d0aafSIngo WeinholdHOST_SHA256					?= ${HOST_SHA256} ;
8858b5934c9SIngo Weinhold
886e173a1ecSIngo WeinholdHOST_HAIKU_PORTER			?= ${HOST_HAIKU_PORTER} ;
887e173a1ecSIngo WeinholdHAIKU_PORTS					?= ${HAIKU_PORTS} ;
888e173a1ecSIngo WeinholdHAIKU_PORTS_CROSS			?= ${HAIKU_PORTS_CROSS} ;
889c9dd05ffSJonathan SchleiferHAIKU_IS_BOOTSTRAP			?= ${HAIKU_IS_BOOTSTRAP} ;
890e173a1ecSIngo Weinhold
891c4786ea6SlilloEOF
892c4786ea6Slillo
893c0e8cc1aSIngo Weinholdfor targetArch in $HAIKU_PACKAGING_ARCHS; do
894c0e8cc1aSIngo Weinhold	variables="
895c0e8cc1aSIngo Weinhold		HAIKU_GCC_RAW_VERSION		HAIKU_GCC_RAW_VERSION
896c0e8cc1aSIngo Weinhold		HAIKU_GCC_MACHINE			HAIKU_GCC_MACHINE
897c0e8cc1aSIngo Weinhold		HAIKU_GCC_LIB_DIR			HAIKU_GCC_LIB_DIR
898c0e8cc1aSIngo Weinhold		HAIKU_CPU					HAIKU_CPU
899c0e8cc1aSIngo Weinhold		HAIKU_BOOT_LIBGCC			HAIKU_BOOT_LIBGCC
900c0e8cc1aSIngo Weinhold		HAIKU_BOOT_LIBSUPC++		HAIKU_BOOT_LIBSUPCXX
901c0e8cc1aSIngo Weinhold		HAIKU_AR					HAIKU_AR
902c0e8cc1aSIngo Weinhold		HAIKU_CC					HAIKU_CC
903c2b76f7fSJonathan Schleifer		HAIKU_CC_IS_CLANG			HAIKU_CC_IS_CLANG
904c0e8cc1aSIngo Weinhold		HAIKU_LD					HAIKU_LD
905c0e8cc1aSIngo Weinhold		HAIKU_OBJCOPY				HAIKU_OBJCOPY
906c0e8cc1aSIngo Weinhold		HAIKU_RANLIB				HAIKU_RANLIB
907c0e8cc1aSIngo Weinhold		HAIKU_ELFEDIT				HAIKU_ELFEDIT
908c0e8cc1aSIngo Weinhold		HAIKU_STRIP					HAIKU_STRIP
909c0e8cc1aSIngo Weinhold		HAIKU_CPPFLAGS				HAIKU_CPPFLAGS
910c0e8cc1aSIngo Weinhold		HAIKU_CCFLAGS				HAIKU_CCFLAGS
911c0e8cc1aSIngo Weinhold		HAIKU_C++FLAGS				HAIKU_CXXFLAGS
912c0e8cc1aSIngo Weinhold		HAIKU_LDFLAGS				HAIKU_LDFLAGS
913c0e8cc1aSIngo Weinhold		HAIKU_ARFLAGS				HAIKU_ARFLAGS
914c0e8cc1aSIngo Weinhold		HAIKU_UNARFLAGS				HAIKU_UNARFLAGS
915c0e8cc1aSIngo Weinhold		HAIKU_USE_GCC_GRAPHITE		HAIKU_USE_GCC_GRAPHITE
916c0e8cc1aSIngo Weinhold		"
917c0e8cc1aSIngo Weinhold	set -- $variables
918c0e8cc1aSIngo Weinhold	while [ $# -ge 2 ]; do
919c0e8cc1aSIngo Weinhold		value=`get_variable ${2}_$targetArch`
920c0e8cc1aSIngo Weinhold		echo "${1}_${targetArch} ?= $value ;" >> "$buildConfigFile"
921c0e8cc1aSIngo Weinhold		shift 2
922c0e8cc1aSIngo Weinhold	done
923b1e5b60cSAxel Dörfler
924c0e8cc1aSIngo Weinhold	# For variables that may have long values, distribute them over multiple
925c0e8cc1aSIngo Weinhold	# lines so that jam doesn't hit the maximum line length.
926c0e8cc1aSIngo Weinhold	variables="
92766a7f29fSJérôme Duval		HAIKU_BOOT_C++_HEADERS_DIR	HAIKU_BOOT_CXX_HEADERS_DIR
928c0e8cc1aSIngo Weinhold		"
929c0e8cc1aSIngo Weinhold	set -- $variables
930c0e8cc1aSIngo Weinhold	while [ $# -ge 2 ]; do
931c0e8cc1aSIngo Weinhold		echo "${1}_${targetArch} ?= " >> "$buildConfigFile"
932c0e8cc1aSIngo Weinhold		get_variable ${2}_$targetArch | xargs -n 1 echo "   " \
933c0e8cc1aSIngo Weinhold			>> "$buildConfigFile"
934c0e8cc1aSIngo Weinhold		echo "    ;" >> "$buildConfigFile"
935c0e8cc1aSIngo Weinhold		shift 2
936c0e8cc1aSIngo Weinhold	done
937c0e8cc1aSIngo Weinholddone
938b1e5b60cSAxel Dörfler
939b1e5b60cSAxel Dörfler
9409b0dd528SIngo Weinhold# Generate a boot strap Jamfile in the output directory.
941338b8dc3SIngo Weinhold
942338b8dc3SIngo Weinholdcat << EOF > $outputDir/Jamfile
943338b8dc3SIngo Weinhold# automatically generated Jamfile
944338b8dc3SIngo Weinhold
945338b8dc3SIngo WeinholdHAIKU_TOP			= ${sourceDir} ;
946338b8dc3SIngo WeinholdHAIKU_OUTPUT_DIR	= ${outputDir} ;
947338b8dc3SIngo Weinhold
948338b8dc3SIngo Weinholdinclude [ FDirName \$(HAIKU_TOP) Jamfile ] ;
949338b8dc3SIngo Weinhold
950338b8dc3SIngo WeinholdEOF
951